import _objectSpread from '@babel/runtime/helpers/esm/objectSpread2';
import _classCallCheck from '@babel/runtime/helpers/esm/classCallCheck';
import _createClass from '@babel/runtime/helpers/esm/createClass';
import _inherits from '@babel/runtime/helpers/esm/inherits';
import _createSuper from '@babel/runtime/helpers/esm/createSuper';
import { isEngine, isMobile, isHotkey, $, isServer, CardActiveTrigger, CardType, Card, Parser, unescape, CARD_KEY, READY_CARD_KEY, decodeCardValue, CARD_VALUE_KEY, CARD_TYPE_KEY, Plugin } from '@aomao/engine';
import _assertThisInitialized from '@babel/runtime/helpers/esm/assertThisInitialized';
import _get from '@babel/runtime/helpers/esm/get';
import _getPrototypeOf from '@babel/runtime/helpers/esm/getPrototypeOf';
import _classPrivateFieldLooseBase from '@babel/runtime/helpers/esm/classPrivateFieldLooseBase';
import _classPrivateFieldLooseKey from '@babel/runtime/helpers/esm/classPrivateFieldLooseKey';
import CodeMirror from 'codemirror';
import { debounce } from 'lodash';
import { defineComponent, resolveComponent, openBlock, createBlock, withCtx, createElementBlock, Fragment, renderList, createTextVNode, toDisplayString, createApp } from 'vue';
import ASelect from 'ant-design-vue/es/select';
import 'ant-design-vue/es/select/style';
import 'codemirror/mode/shell/shell';
import 'codemirror/mode/clike/clike';
import 'codemirror/mode/css/css';
import 'codemirror/mode/dart/dart';
import 'codemirror/mode/diff/diff';
import 'codemirror/mode/dockerfile/dockerfile';
import 'codemirror/mode/erlang/erlang';
import 'codemirror/mode/go/go';
import 'codemirror/mode/groovy/groovy';
import 'codemirror/mode/htmlmixed/htmlmixed';
import 'codemirror/mode/http/http';
import 'codemirror/mode/javascript/javascript';
import 'codemirror/mode/jsx/jsx';
import 'codemirror/mode/cmake/cmake';
import 'codemirror/mode/markdown/markdown';
import 'codemirror/mode/octave/octave';
import 'codemirror/mode/nginx/nginx';
import 'codemirror/mode/pascal/pascal';
import 'codemirror/mode/perl/perl';
import 'codemirror/mode/php/php';
import 'codemirror/mode/powershell/powershell';
import 'codemirror/mode/protobuf/protobuf';
import 'codemirror/mode/python/python';
import 'codemirror/mode/r/r';
import 'codemirror/mode/ruby/ruby';
import 'codemirror/mode/rust/rust';
import 'codemirror/mode/sql/sql';
import 'codemirror/mode/swift/swift';
import 'codemirror/mode/vb/vb';
import 'codemirror/mode/velocity/velocity';
import 'codemirror/mode/xml/xml';
import 'codemirror/mode/yaml/yaml';
import 'codemirror/addon/scroll/simplescrollbars';
import 'codemirror/addon/scroll/simplescrollbars.css';
import 'codemirror/mode/properties/properties';

var qa = ['c', 'cpp', 'csharp', 'erlang', 'go', 'groovy', 'java', 'kotlin', 'makefile', 'objectivec', 'perl', 'python', 'rust', 'swift', 'vbnet'];

var CodeBlockEditor = /*#__PURE__*/function () {
  function CodeBlockEditor(editor, options) {
    _classCallCheck(this, CodeBlockEditor);

    this.editor = void 0;
    this.options = void 0;
    this.codeMirror = void 0;
    this.mode = 'plain';
    this.container = void 0;
    this.editor = editor;
    this.options = options;
    this.container = options.container || $(this.renderTemplate());
  }

  _createClass(CodeBlockEditor, [{
    key: "renderTemplate",
    value: function renderTemplate() {
      return '<div class="data-codeblock-container"><div class="data-codeblock-content"></div></div>';
    }
  }, {
    key: "getConfig",
    value: function getConfig(value, mode) {
      var tabSize = this.codeMirror ? this.codeMirror.getOption('indentUnit') : qa.indexOf(mode || '') > -1 ? 4 : 2;
      var reg = value ? value.match(/^ {2,4}(?=[^\s])/gm) : null;

      if (reg) {
        tabSize = reg.reduce(function (val1, val2) {
          return Math.min(val1, val2.length);
        }, 1 / 0);
      }

      return {
        tabSize: tabSize,
        indentUnit: tabSize,
        scrollbarStyle: 'simple',
        readOnly: !isEngine(this.editor) || this.editor.readonly,
        viewportMargin: Infinity
      };
    }
  }, {
    key: "getSyntax",
    value: function getSyntax(mode) {
      return this.options.synatxMap[mode] || mode;
    }
  }, {
    key: "create",
    value: function create(mode, value, options) {
      var _this = this;

      this.mode = mode;
      var syntaxMode = this.getSyntax(mode);
      this.codeMirror = CodeMirror(this.container.find('.data-codeblock-content').get(), _objectSpread(_objectSpread({
        value: value,
        mode: syntaxMode,
        lineNumbers: true,
        lineWrapping: false,
        autofocus: false,
        dragDrop: false
      }, this.getConfig(value, syntaxMode)), options));
      this.codeMirror.on('mousedown', function (_, event) {
        if (!isEngine(_this.editor) || _this.editor.readonly) {
          event.preventDefault();
          event.stopPropagation();
        }
      });
      this.codeMirror.on('focus', function () {
        var onFocus = _this.options.onFocus;
        if (onFocus) onFocus();
      });
      this.codeMirror.on('blur', function () {
        var _this$codeMirror;

        var onBlur = _this.options.onBlur;
        (_this$codeMirror = _this.codeMirror) === null || _this$codeMirror === void 0 ? void 0 : _this$codeMirror.setCursor(_this.codeMirror.lineCount() - 1, 0);
        if (onBlur) onBlur();
      });

      if (isMobile) {
        this.codeMirror.on('touchstart', function (_, event) {
          var onMouseDown = _this.options.onMouseDown;
          if (onMouseDown) onMouseDown(event);
        });
      } else {
        this.codeMirror.on('mousedown', function (_, event) {
          var onMouseDown = _this.options.onMouseDown;
          if (onMouseDown) onMouseDown(event);
        });
      }

      this.codeMirror.on('change', debounce(function () {
        if (!isEngine(_this.editor)) return;

        _this.save();
      }, 50));
      this.codeMirror.setOption('extraKeys', {
        Enter: function Enter(mirror) {
          var config = _this.getConfig(mirror.getValue());

          Object.keys(config).forEach(function (key) {
            return mirror.setOption(key, config[key]);
          });
          mirror.execCommand('newlineAndIndent');
        }
      });
      this.codeMirror.on('keydown', function (editor, event) {
        event.stopPropagation(); // if (
        // 	isHotkey('mod+z', event) ||
        // 	isHotkey('mod+y', event) ||
        // 	isHotkey('mode+shift+z', event)
        // ) {
        // 	event.stopPropagation();
        // }

        var lineCount = editor.lineCount();

        var _editor$getCursor = editor.getCursor(),
            line = _editor$getCursor.line,
            ch = _editor$getCursor.ch;

        var _this$options = _this.options,
            onUpFocus = _this$options.onUpFocus,
            onDownFocus = _this$options.onDownFocus,
            onLeftFocus = _this$options.onLeftFocus,
            onRightFocus = _this$options.onRightFocus;
        var content = editor.getLine(line); // 在最后一行

        if (line === lineCount - 1 && ch === content.length) {
          // 按下下键
          if (isHotkey('down', event) || isHotkey('ctrl+n', event)) {
            if (onDownFocus) onDownFocus(event);
            return;
          } // 按下右键
          else if (isHotkey('right', event) || isHotkey('shift+right', event) || isHotkey('ctrl+e', event) || isHotkey('ctrl+f', event)) {
            if (onRightFocus) onRightFocus(event);
            return;
          }
        } // 在第一行按下上键


        if (line === 0 && ch === 0) {
          // 按下上键
          if (isHotkey('up', event) || isHotkey('ctrl+p', event)) {
            if (onUpFocus) onUpFocus(event);
          } // 按下左键
          else if (isHotkey('left', event) || isHotkey('shift+left', event) || isHotkey('ctrl+b', event) || isHotkey('ctrl+a', event)) {
            if (onLeftFocus) onLeftFocus(event);
          }
        }

        if (isHotkey('shift+tab', event)) {
          event.preventDefault();
          event.stopPropagation();
          editor.indentSelection('subtract');
        }
      });
      this.container.on('mousedown', function (event) {
        var _this$codeMirror2;

        if (!((_this$codeMirror2 = _this.codeMirror) === null || _this$codeMirror2 === void 0 ? void 0 : _this$codeMirror2.hasFocus())) {
          setTimeout(function () {
            var _this$codeMirror3;

            (_this$codeMirror3 = _this.codeMirror) === null || _this$codeMirror3 === void 0 ? void 0 : _this$codeMirror3.focus();
          }, 0);
        }
      });
      return this.codeMirror;
    }
  }, {
    key: "setAutoWrap",
    value: function setAutoWrap(value) {
      var _this$codeMirror4;

      (_this$codeMirror4 = this.codeMirror) === null || _this$codeMirror4 === void 0 ? void 0 : _this$codeMirror4.setOption('lineWrapping', value);
    }
  }, {
    key: "update",
    value: function update(mode, code) {
      var _this$codeMirror6, _this$codeMirror7;

      this.mode = mode;

      if (code !== undefined) {
        var _this$codeMirror5;

        (_this$codeMirror5 = this.codeMirror) === null || _this$codeMirror5 === void 0 ? void 0 : _this$codeMirror5.setValue(code);
      }

      (_this$codeMirror6 = this.codeMirror) === null || _this$codeMirror6 === void 0 ? void 0 : _this$codeMirror6.setOption('mode', this.getSyntax(mode));
      (_this$codeMirror7 = this.codeMirror) === null || _this$codeMirror7 === void 0 ? void 0 : _this$codeMirror7.setOption('readOnly', !isEngine(this.editor) || this.editor.readonly ? true : false);
      this.save();
    }
  }, {
    key: "render",
    value: function render(mode, value, options) {
      var root = this.container.find('.data-codeblock-content');
      mode = this.getSyntax(mode);
      var stage = $('<div class="CodeMirror"><pre class="cm-s-default" /></div>');
      root.append(stage);
      var pre = stage.find('pre')[0];
      this.runMode(value || '', mode, pre, _objectSpread(_objectSpread({}, this.getConfig(value, mode)), options));
    }
  }, {
    key: "save",
    value: function save() {
      if (!isEngine(this.editor) || !this.codeMirror) return; // 中文输入过程需要判断

      if (this.editor.change.isComposing()) {
        return;
      }

      var value = this.codeMirror.getValue();
      var onSave = this.options.onSave;
      if (onSave) onSave(this.mode, value);
    }
  }, {
    key: "focus",
    value: function focus() {
      if (!this.codeMirror) return;
      this.codeMirror.focus();
    }
  }, {
    key: "select",
    value: function select() {
      var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
      if (!this.codeMirror) return;
      this.codeMirror.focus();

      if (!start) {
        var line = this.codeMirror.lineCount() - 1;
        var content = this.codeMirror.getLine(line);
        this.codeMirror.setSelection({
          line: line,
          ch: content.length
        });
      } else {
        this.codeMirror.setSelection({
          line: 0,
          ch: 0
        });
      }
    }
    /**
     * 代码来自 runmode addon
     * 支持行号需要考虑复制粘贴问题
     *
     * runmode 本身不支持行号，见 https://github.com/codemirror/CodeMirror/issues/3364
     * 可参考的解法  https://stackoverflow.com/questions/14237361/use-codemirror-for-standalone-syntax-highlighting-with-line-numbers
     *
     * ref:
     * - https://codemirror.net/doc/manual.html#addons
     * - https://codemirror.net/addon/runmode/runmode.js
     */

  }, {
    key: "runMode",
    value: function runMode(string, modespec, callback, options) {
      var mode = CodeMirror.getMode(CodeMirror.defaults, modespec);
      var ie = /MSIE \d/.test(navigator.userAgent);

      if (callback.appendChild) {
        var tabSize = options && options.tabSize || CodeMirror.defaults.tabSize;
        var node = callback;
        var col = 0;
        node.innerHTML = '';

        callback = function callback(text, style) {
          if (text === '\n') {
            // Emitting LF or CRLF on IE8 or earlier results in an incorrect display.
            // Emitting a carriage return makes everything ok.
            var lineCode = document.createElement('br');
            node.appendChild(lineCode);
            col = 0;
            return;
          }

          var content = ''; // replace tabs

          for (var pos = 0;;) {
            var idx = text.indexOf('\t', pos);

            if (idx === -1) {
              content += text.slice(pos);
              col += text.length - pos;
              break;
            } else {
              col += idx - pos;
              content += text.slice(pos, idx);
              var size = tabSize - col % tabSize;
              col += size;

              for (var i = 0; i < size; ++i) {
                content += ' ';
              }

              pos = idx + 1;
            }
          }

          if (style) {
            var sp = node.appendChild(document.createElement('span'));
            sp.className = 'cm-' + style.replace(/ +/g, ' cm-');
            sp.appendChild(document.createTextNode(content));
          } else {
            node.appendChild(document.createTextNode(content));
          }
        };
      }

      var lines = CodeMirror.splitLines(string);
      var state = options && options.state || CodeMirror.startState(mode);

      for (var i = 0, e = lines.length; i < e; ++i) {
        if (i) callback('\n');
        var stream = new CodeMirror.StringStream(lines[i]);
        if (!stream.string && mode.blankLine) mode.blankLine(state);

        while (!stream.eol()) {
          var style = mode.token ? mode.token(stream, state) : '';
          callback(stream.current(), style, i, stream.start, state);
          stream.start = stream.pos;
        }
      }
    }
  }]);

  return CodeBlockEditor;
}();

var ASelectOption = ASelect.Option;
var script = defineComponent({
  name: "am-codeblock-select",
  components: {
    ASelect: ASelect,
    ASelectOption: ASelectOption
  },
  props: {
    modeDatas: Array,
    defaultValue: String,
    getContainer: Function,
    onSelect: Function
  },
  methods: {
    filter: function filter(input, option) {
      input = input.toLowerCase();
      var key = option.key || '';
      var name = option.name || '';
      name = name.toLowerCase();
      return key.includes(input) || name.includes(input);
    }
  }
});

function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_a_select_option = resolveComponent("a-select-option");

  var _component_a_select = resolveComponent("a-select");

  return openBlock(), createBlock(_component_a_select, {
    "show-search": true,
    size: "small",
    bordered: false,
    style: {
      "min-width": "128px"
    },
    "default-value": _ctx.defaultValue,
    "get-popup-container": _ctx.getContainer,
    onSelect: _ctx.onSelect,
    "filter-option": _ctx.filter
  }, {
    default: withCtx(function () {
      return [(openBlock(true), createElementBlock(Fragment, null, renderList(_ctx.modeDatas, function (item) {
        return openBlock(), createBlock(_component_a_select_option, {
          name: item.name,
          value: item.value,
          key: item.value
        }, {
          default: withCtx(function () {
            return [createTextVNode(toDisplayString(item.name), 1
            /* TEXT */
            )];
          }),
          _: 2
          /* DYNAMIC */

        }, 1032
        /* PROPS, DYNAMIC_SLOTS */
        , ["name", "value"]);
      }), 128
      /* KEYED_FRAGMENT */
      ))];
    }),
    _: 1
    /* STABLE */

  }, 8
  /* PROPS */
  , ["default-value", "get-popup-container", "onSelect", "filter-option"]);
}

script.render = render;
script.__file = "src/component/select/component.vue";

var renderSelect = (function (container, modeDatas, defaultValue, onSelect) {
  var vm = createApp(script, {
    modeDatas: modeDatas,
    defaultValue: defaultValue,
    getContainer: container ? function () {
      return container;
    } : undefined,
    onSelect: onSelect
  });
  vm.mount(container);
  return vm;
});

var datas = [{
  value: 'plain',
  syntax: 'simplemode',
  name: 'Plain Text'
}, {
  value: 'bash',
  syntax: 'shell',
  name: 'Bash'
}, {
  value: 'shell',
  syntax: 'shell',
  name: 'Shell'
}, {
  value: 'basic',
  syntax: 'vbscript',
  name: 'Basic'
}, {
  value: 'c',
  syntax: 'text/x-csrc',
  name: 'C'
}, {
  value: 'cpp',
  syntax: 'text/x-c++src',
  name: 'C++'
}, {
  value: 'properties',
  syntax: 'properties',
  name: 'Properties'
}, {
  value: 'csharp',
  syntax: 'text/x-csharp',
  name: 'C#'
}, {
  value: 'css',
  syntax: 'css',
  name: 'CSS'
}, {
  value: 'dart',
  syntax: 'dart',
  name: 'Dart'
}, {
  value: 'diff',
  syntax: 'diff',
  name: 'Diff'
}, {
  value: 'dockerfile',
  syntax: 'dockerfile',
  name: 'Dockerfile'
}, {
  value: 'erlang',
  syntax: 'erlang',
  name: 'Erlang'
}, {
  value: 'git',
  syntax: 'shell',
  name: 'Git'
}, {
  value: 'go',
  syntax: 'go',
  name: 'Go'
}, {
  value: 'graphql',
  syntax: 'simplemode',
  name: 'GraphQL'
}, {
  value: 'groovy',
  syntax: 'groovy',
  name: 'Groovy'
}, {
  value: 'html',
  syntax: 'htmlmixed',
  name: 'HTML'
}, {
  value: 'http',
  syntax: 'http',
  name: 'HTTP'
}, {
  value: 'java',
  syntax: 'text/x-java',
  name: 'Java'
}, {
  value: 'javascript',
  syntax: 'text/javascript',
  name: 'JavaScript'
}, {
  value: 'json',
  syntax: 'application/json',
  name: 'JSON'
}, {
  value: 'jsx',
  syntax: 'jsx',
  name: 'JSX'
}, {
  value: 'katex',
  syntax: 'simplemode',
  name: 'KaTeX'
}, {
  value: 'kotlin',
  syntax: 'text/x-kotlin',
  name: 'Kotlin'
}, {
  value: 'less',
  syntax: 'css',
  name: 'Less'
}, {
  value: 'makefile',
  syntax: 'cmake',
  name: 'Makefile'
}, {
  value: 'markdown',
  syntax: 'markdown',
  name: 'Markdown'
}, {
  value: 'matlab',
  syntax: 'octave',
  name: 'MATLAB'
}, {
  value: 'nginx',
  syntax: 'nginx',
  name: 'Nginx'
}, {
  value: 'objectivec',
  syntax: 'text/x-objectivec',
  name: 'Objective-C'
}, {
  value: 'pascal',
  syntax: 'pascal',
  name: 'Pascal'
}, {
  value: 'perl',
  syntax: 'perl',
  name: 'Perl'
}, {
  value: 'php',
  syntax: 'php',
  name: 'PHP'
}, {
  value: 'powershell',
  syntax: 'powershell',
  name: 'PowerShell'
}, {
  value: 'protobuf',
  syntax: 'protobuf',
  name: 'Protobuf'
}, {
  value: 'python',
  syntax: 'python',
  name: 'Python'
}, {
  value: 'r',
  syntax: 'r',
  name: 'R'
}, {
  value: 'ruby',
  syntax: 'ruby',
  name: 'Ruby'
}, {
  value: 'rust',
  syntax: 'rust',
  name: 'Rust'
}, {
  value: 'scala',
  syntax: 'text/x-scala',
  name: 'Scala'
}, {
  value: 'shell',
  syntax: 'shell',
  name: 'Shell'
}, {
  value: 'sql',
  syntax: 'text/x-sql',
  name: 'SQL'
}, {
  value: 'swift',
  syntax: 'swift',
  name: 'Swift'
}, {
  value: 'typescript',
  syntax: 'text/typescript',
  name: 'TypeScript'
}, {
  value: 'vbnet',
  syntax: 'vb',
  name: 'VB.net'
}, {
  value: 'velocity',
  syntax: 'velocity',
  name: 'Velocity'
}, {
  value: 'xml',
  syntax: 'xml',
  name: 'XML'
}, {
  value: 'yaml',
  syntax: 'yaml',
  name: 'YAML'
}];

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".data-codeblock-container {\n     position: relative;\n     padding: 0;\n     overflow: visible;\n     border: 1px solid #e8e8e8;\n     border-radius: 2px 2px;\n     text-indent: 0;\n }\n \n .data-codeblock-container .am-embed-toolbar-item {\n     float: right;\n     line-height: 32px;\n }\n \n .data-codeblock-content {\n      background: #f9f9f9;\n      overflow: auto;\n }\n \n .am-engine .CodeMirror,\n .am-engine-view .CodeMirror {\n      font-family: monospace;\n      font-size: 13px;\n      line-height: 21px;\n      color: #595959;\n      direction: ltr;\n      height: auto;\n      overflow: hidden;\n      background: transparent;\n }\n \n .am-engine .CodeMirror-lines,\n .am-engine-view .CodeMirror-lines {\n      padding: 8px 0;\n }\n \n .am-engine .CodeMirror-scrollbar-filler,\n .am-engine-view .CodeMirror-scrollbar-filler,\n .am-engine .CodeMirror-gutter-filler,\n .am-engine-view .CodeMirror-gutter-filler {\n      background-color: white;\n     \n     /* The little square between H and V scrollbars */\n     \n }\n \n .am-engine .CodeMirror-gutters,\n .am-engine-view .CodeMirror-gutters {\n      border: 0;\n      white-space: nowrap;\n      padding: 0 8px;\n      background-color: unset;\n     \n }\n \n .am-engine .CodeMirror-linenumber,\n .am-engine-view .CodeMirror-linenumber {\n      padding: 0;\n      min-width: 20px;\n      text-align: right;\n      color: #BFBFBF;\n      white-space: nowrap;\n     \n }\n \n .am-engine .CodeMirror-guttermarker,\n .am-engine-view .CodeMirror-guttermarker {\n      color: black;\n     \n }\n \n .am-engine .CodeMirror-guttermarker-subtle,\n .am-engine-view .CodeMirror-guttermarker-subtle {\n      color: #999;\n     \n }\n \n .am-engine .CodeMirror-cursor,\n .am-engine-view .CodeMirror-cursor {\n      border-left: 1px solid black;\n      border-right: none;\n      width: 0;\n     \n }\n \n .am-engine .CodeMirror div.CodeMirror-secondarycursor,\n .am-engine-view .CodeMirror div.CodeMirror-secondarycursor {\n      border-left: 1px solid silver;\n     \n }\n \n .am-engine .cm-fat-cursor .CodeMirror-cursor,\n .am-engine-view .cm-fat-cursor .CodeMirror-cursor {\n      width: auto;\n      border: 0 !important;\n      background: #7e7;\n     \n }\n \n .am-engine .cm-fat-cursor div.CodeMirror-cursors,\n .am-engine-view .cm-fat-cursor div.CodeMirror-cursors {\n      z-index: 1;\n     \n }\n \n .am-engine .cm-fat-cursor-mark,\n .am-engine-view .cm-fat-cursor-mark {\n      background-color: rgba(20, 255, 20, 0.5);\n      -webkit-animation: blink 1.06s steps(1) infinite;\n      animation: blink 1.06s steps(1) infinite;\n     \n }\n \n .am-engine .cm-animate-fat-cursor,\n .am-engine-view .cm-animate-fat-cursor {\n      width: auto;\n      border: 0;\n      -webkit-animation: blink 1.06s steps(1) infinite;\n      animation: blink 1.06s steps(1) infinite;\n      background-color: #7e7;\n     \n }\n \n @-webkit-keyframes blink {\n      50% {\n          background-color: transparent;\n         \n     }\n \n     \n }\n \n @keyframes blink {\n      50% {\n          background-color: transparent;\n         \n     }\n \n     \n }\n \n .am-engine .cm-tab,\n .am-engine-view .cm-tab {\n      display: inline-block;\n      text-decoration: inherit;\n     \n }\n \n .am-engine .CodeMirror-rulers,\n .am-engine-view .CodeMirror-rulers {\n      position: absolute;\n      left: 0;\n      right: 0;\n      top: -50px;\n      bottom: -20px;\n      overflow: hidden;\n     \n }\n \n .am-engine .CodeMirror-ruler,\n .am-engine-view .CodeMirror-ruler {\n      border-left: 1px solid #ccc;\n      top: 0;\n      bottom: 0;\n      position: absolute;\n     \n }\n \n .am-engine .cm-s-default .cm-header,\n .am-engine-view .cm-s-default .cm-header {\n      color: blue;\n     \n }\n \n .am-engine .cm-s-default .cm-quote,\n .am-engine-view .cm-s-default .cm-quote {\n      color: #090;\n     \n }\n \n .am-engine .cm-negative,\n .am-engine-view .cm-negative {\n      color: #d44;\n     \n }\n \n .am-engine .cm-positive,\n .am-engine-view .cm-positive {\n      color: #292;\n     \n }\n \n .am-engine .cm-header,\n .am-engine-view .cm-header,\n .am-engine .cm-strong,\n .am-engine-view .cm-strong {\n      font-weight: bold;\n     \n }\n \n .am-engine .cm-em,\n .am-engine-view .cm-em {\n      font-style: italic;\n     \n }\n \n .am-engine .cm-link,\n .am-engine-view .cm-link {\n      text-decoration: underline;\n     \n }\n \n .am-engine .cm-strikethrough,\n .am-engine-view .cm-strikethrough {\n      text-decoration: line-through;\n     \n }\n \n .am-engine .cm-s-default .cm-keyword,\n .am-engine-view .cm-s-default .cm-keyword {\n      color: #d73a49;\n     \n }\n \n .am-engine .cm-s-default .cm-atom,\n .am-engine-view .cm-s-default .cm-atom {\n      color: #905;\n     \n }\n \n .am-engine .cm-s-default .cm-number,\n .am-engine-view .cm-s-default .cm-number {\n      color: #005cc5;\n     \n }\n \n .am-engine .cm-s-default .cm-def,\n .am-engine-view .cm-s-default .cm-def {\n      color: #005cc5;\n     \n }\n \n .am-engine .cm-s-default .cm-variable-2,\n .am-engine-view .cm-s-default .cm-variable-2 {\n      color: #005cc5;\n     \n }\n \n .am-engine .cm-s-default .cm-variable-3,\n .am-engine-view .cm-s-default .cm-variable-3,\n .am-engine .cm-s-default .cm-type,\n .am-engine-view .cm-s-default .cm-type {\n      color: #22863a;\n     \n }\n \n .am-engine .cm-s-default .cm-comment,\n .am-engine-view .cm-s-default .cm-comment {\n      color: #6a737d;\n     \n }\n \n .am-engine .cm-s-default .cm-string,\n .am-engine-view .cm-s-default .cm-string {\n      color: #690;\n     \n }\n \n .am-engine .cm-s-default .cm-string-2,\n .am-engine-view .cm-s-default .cm-string-2 {\n      color: #690;\n     \n }\n \n .am-engine .cm-s-default .cm-meta,\n .am-engine-view .cm-s-default .cm-meta {\n      color: #1f7f9a;\n     \n }\n \n .am-engine .cm-s-default .cm-qualifier,\n .am-engine-view .cm-s-default .cm-qualifier {\n      color: #555;\n     \n }\n \n .am-engine .cm-s-default .cm-builtin,\n .am-engine-view .cm-s-default .cm-builtin {\n      color: #6f42c1;\n     \n }\n \n .am-engine .cm-s-default .cm-bracket,\n .am-engine-view .cm-s-default .cm-bracket {\n      color: #997;\n     \n }\n \n .am-engine .cm-s-default .cm-tag,\n .am-engine-view .cm-s-default .cm-tag {\n      color: #22863a;\n     \n }\n \n .am-engine .cm-s-default .cm-attribute,\n .am-engine-view .cm-s-default .cm-attribute {\n      color: #6f42c1;\n     \n }\n \n .am-engine .cm-s-default .cm-hr,\n .am-engine-view .cm-s-default .cm-hr {\n      color: #999;\n     \n }\n \n .am-engine .cm-s-default .cm-link,\n .am-engine-view .cm-s-default .cm-link {\n      color: #00c;\n     \n }\n \n .am-engine .cm-s-default .cm-error,\n .am-engine-view .cm-s-default .cm-error {\n      color: #f00;\n     \n }\n \n .am-engine .cm-invalidchar,\n .am-engine-view .cm-invalidchar {\n      color: #f00;\n     \n }\n \n .am-engine .cm-s-default .cm-operator,\n .am-engine-view .cm-s-default .cm-operator {\n      color: #d73a49;\n     \n }\n \n .am-engine .cm-s-default .cm-property,\n .am-engine-view .cm-s-default .cm-property {\n      color: #005cc5;\n     \n }\n \n .am-engine .CodeMirror-composing,\n .am-engine-view .CodeMirror-composing {\n      border-bottom: 2px solid;\n     \n }\n \n .am-engine div.CodeMirror span.CodeMirror-matchingbracket,\n .am-engine-view div.CodeMirror span.CodeMirror-matchingbracket {\n      color: #0b0;\n     \n }\n \n .am-engine div.CodeMirror span.CodeMirror-nonmatchingbracket,\n .am-engine-view div.CodeMirror span.CodeMirror-nonmatchingbracket {\n      color: #a22;\n     \n }\n \n .am-engine .CodeMirror-matchingtag,\n .am-engine-view .CodeMirror-matchingtag {\n      background: rgba(255, 150, 0, 0.3);\n     \n }\n \n .am-engine .CodeMirror-activeline-background,\n .am-engine-view .CodeMirror-activeline-background {\n      background: transparent;\n     \n }\n \n .am-engine .CodeMirror-scroll,\n .am-engine-view .CodeMirror-scroll {\n      overflow: scroll !important;\n     \n     /* Things will break if this is overridden */\n     \n     /* 30px is the magic margin used to hide the element's real scrollbars */\n     \n     /* See overflow: hidden in .CodeMirror */\n      margin-bottom: -50px;\n      margin-right: -50px;\n      padding-bottom: 50px;\n      outline: none;\n     \n     /* Prevent dragging from highlighting the element */\n      position: relative;\n      z-index: 0;\n     \n }\n \n .am-engine .CodeMirror-sizer,\n .am-engine-view .CodeMirror-sizer {\n      position: relative;\n      border-right: 50px solid transparent;\n      min-height: auto !important;\n     \n }\n \n .am-engine .CodeMirror-vscrollbar,\n .am-engine-view .CodeMirror-vscrollbar,\n .am-engine .CodeMirror-hscrollbar,\n .am-engine-view .CodeMirror-hscrollbar,\n .am-engine .CodeMirror-scrollbar-filler,\n .am-engine-view .CodeMirror-scrollbar-filler,\n .am-engine .CodeMirror-gutter-filler,\n .am-engine-view .CodeMirror-gutter-filler {\n      position: absolute;\n      z-index: 6;\n      display: none;\n     \n }\n \n .am-engine .CodeMirror-vscrollbar,\n .am-engine-view .CodeMirror-vscrollbar {\n      right: 0;\n      top: 0;\n      overflow-x: hidden;\n      overflow-y: scroll;\n      display: none;\n     \n }\n \n .am-engine .CodeMirror-hscrollbar,\n .am-engine-view .CodeMirror-hscrollbar {\n      bottom: 0;\n      left: 0;\n      overflow-y: hidden;\n      overflow-x: scroll;\n      display: none;\n     \n }\n \n .am-engine .CodeMirror-scrollbar-filler,\n .am-engine-view .CodeMirror-scrollbar-filler {\n      right: 0;\n      bottom: 0;\n     \n }\n \n .am-engine .CodeMirror-gutter-filler,\n .am-engine-view .CodeMirror-gutter-filler {\n      left: 0;\n      bottom: 0;\n     \n }\n \n .am-engine .CodeMirror-gutters,\n .am-engine-view .CodeMirror-gutters {\n      position: absolute;\n      left: 0;\n      top: 0;\n      min-height: 100%;\n      background: #f9f9f9;\n      z-index: 3;\n }\n \n .am-engine .CodeMirror-gutter,\n .am-engine-view .CodeMirror-gutter {\n      white-space: normal;\n      height: 100%;\n      display: inline-block;\n      vertical-align: top;\n      margin-bottom: -30px;\n     \n }\n \n .am-engine .CodeMirror-gutter-wrapper,\n .am-engine-view .CodeMirror-gutter-wrapper {\n      position: absolute;\n      z-index: 4;\n      background: none !important;\n      border: none !important;\n     \n }\n \n .am-engine .CodeMirror-gutter-background,\n .am-engine-view .CodeMirror-gutter-background {\n      position: absolute;\n      top: 0;\n      bottom: 0;\n      z-index: 4;\n     \n }\n \n .am-engine .CodeMirror-gutter-elt,\n .am-engine-view .CodeMirror-gutter-elt {\n      position: absolute;\n      cursor: default;\n      z-index: 4;\n     \n }\n \n .am-engine .CodeMirror-gutter-wrapper ::-moz-selection,\n .am-engine-view .CodeMirror-gutter-wrapper ::-moz-selection {\n      background-color: transparent;\n     \n }\n \n .am-engine .CodeMirror-gutter-wrapper ::selection,\n .am-engine-view .CodeMirror-gutter-wrapper ::selection {\n      background-color: transparent;\n     \n }\n \n .am-engine .CodeMirror-gutter-wrapper ::-moz-selection,\n .am-engine-view .CodeMirror-gutter-wrapper ::-moz-selection {\n      background-color: transparent;\n     \n }\n \n .am-engine .CodeMirror-lines,\n .am-engine-view .CodeMirror-lines {\n      cursor: text;\n      min-height: 40px;\n     \n     /* prevents collapsing before first draw */\n     \n }\n \n .am-engine .CodeMirror pre,\n .am-engine-view .CodeMirror pre {\n     \n     /* Reset some styles that the rest of the page might have set */\n      border-radius: 0;\n      border-width: 0;\n      background: transparent;\n      font-family: inherit;\n      font-size: inherit;\n      margin: 0;\n      white-space: pre;\n      word-wrap: normal;\n      line-height: inherit;\n      color: inherit;\n      z-index: 2;\n      position: relative;\n      overflow: visible;\n      -webkit-tap-highlight-color: transparent;\n      font-variant-ligatures: contextual;\n     \n }\n \n .am-engine .CodeMirror-wrap pre,\n .am-engine-view .CodeMirror-wrap pre {\n      word-wrap: break-word;\n      white-space: pre-wrap;\n      word-break: normal;\n     \n }\n \n .am-engine .CodeMirror-linebackground,\n .am-engine-view .CodeMirror-linebackground {\n      position: absolute;\n      left: 0;\n      right: 0;\n      top: 0;\n      bottom: 0;\n      z-index: 0;\n     \n }\n \n .am-engine .CodeMirror-linewidget,\n .am-engine-view .CodeMirror-linewidget {\n      position: relative;\n      z-index: 2;\n      padding: 0.1px;\n     \n     /* Force widget margins to stay inside of the container */\n     \n }\n \n .am-engine .CodeMirror-rtl pre,\n .am-engine-view .CodeMirror-rtl pre {\n      direction: rtl;\n     \n }\n \n .am-engine .CodeMirror-code,\n .am-engine-view .CodeMirror-code {\n      outline: none;\n     \n }\n \n .am-engine .CodeMirror-scroll,\n .am-engine-view .CodeMirror-scroll,\n .am-engine .CodeMirror-sizer,\n .am-engine-view .CodeMirror-sizer,\n .am-engine .CodeMirror-gutter,\n .am-engine-view .CodeMirror-gutter,\n .am-engine .CodeMirror-gutters,\n .am-engine-view .CodeMirror-gutters,\n .am-engine .CodeMirror-linenumber,\n .am-engine-view .CodeMirror-linenumber {\n      box-sizing: content-box;\n     \n }\n \n .am-engine .CodeMirror-simplescroll-horizontal, .am-engine-view .CodeMirror-simplescroll-horizontal {\n      bottom: 4px;\n      cursor: pointer;\n }\n \n .am-engine .CodeMirror-measure,\n .am-engine-view .CodeMirror-measure {\n      position: absolute;\n      width: 100%;\n      height: 0;\n      overflow: hidden;\n      visibility: hidden;\n     \n }\n \n .am-engine .CodeMirror-cursor,\n .am-engine-view .CodeMirror-cursor {\n      position: absolute;\n      pointer-events: none;\n     \n }\n \n .am-engine .CodeMirror-measure pre,\n .am-engine-view .CodeMirror-measure pre {\n      position: static;\n     \n }\n \n .am-engine div.CodeMirror-cursors,\n .am-engine-view div.CodeMirror-cursors {\n      visibility: hidden;\n      position: relative;\n      z-index: 3;\n     \n }\n \n .am-engine div.CodeMirror-dragcursors,\n .am-engine-view div.CodeMirror-dragcursors {\n      visibility: visible;\n     \n }\n \n .am-engine .CodeMirror-focused div.CodeMirror-cursors,\n .am-engine-view .CodeMirror-focused div.CodeMirror-cursors {\n      visibility: visible;\n     \n }\n \n .am-engine .CodeMirror-selected,\n .am-engine-view .CodeMirror-selected {\n      background: #e8e8e8;\n     \n }\n \n .am-engine .CodeMirror-focused .CodeMirror-selected,\n .am-engine-view .CodeMirror-focused .CodeMirror-selected {\n      background: #b3d7fd;\n     \n }\n \n .am-engine .CodeMirror-crosshair,\n .am-engine-view .CodeMirror-crosshair {\n      cursor: crosshair;\n     \n }\n \n .am-engine .CodeMirror-line::-moz-selection,\n .am-engine-view .CodeMirror-line::-moz-selection,\n .am-engine .CodeMirror-line>span::-moz-selection,\n .am-engine-view .CodeMirror-line>span::-moz-selection,\n .am-engine .CodeMirror-line>span>span::-moz-selection,\n .am-engine-view .CodeMirror-line>span>span::-moz-selection {\n      background: #b3d7fd;\n     \n }\n \n .am-engine .CodeMirror-line::selection,\n .am-engine-view .CodeMirror-line::selection,\n .am-engine .CodeMirror-line>span::selection,\n .am-engine-view .CodeMirror-line>span::selection,\n .am-engine .CodeMirror-line>span>span::selection,\n .am-engine-view .CodeMirror-line>span>span::selection {\n      background: #b3d7fd;\n     \n }\n \n .am-engine .CodeMirror-line::-moz-selection,\n .am-engine-view .CodeMirror-line::-moz-selection,\n .am-engine .CodeMirror-line>span::-moz-selection,\n .am-engine-view .CodeMirror-line>span::-moz-selection,\n .am-engine .CodeMirror-line>span>span::-moz-selection,\n .am-engine-view .CodeMirror-line>span>span::-moz-selection {\n      background: #b3d7fd;\n     \n }\n \n .am-engine .cm-searching,\n .am-engine-view .cm-searching {\n      background-color: #ffa;\n      background-color: rgba(255, 255, 0, 0.4);\n     \n }\n \n .am-engine .cm-force-border,\n .am-engine-view .cm-force-border {\n      padding-right: 0.1px;\n     \n }\n \n @media print {\n \n     /* .am-engine,\n      .am-engine-view { */\n         \n         /* Hide the cursor when printing */\n         \n     /* } */\n \n      .am-engine .CodeMirror div.CodeMirror-cursors,\n      .am-engine-view .CodeMirror div.CodeMirror-cursors {\n          visibility: hidden;\n         \n     }\n \n     \n }\n \n .am-engine .cm-tab-wrap-hack:after,\n .am-engine-view .cm-tab-wrap-hack:after {\n      content: '';\n     \n }\n \n .am-engine span.CodeMirror-selectedtext,\n .am-engine-view span.CodeMirror-selectedtext {\n      background: none;\n     \n }\n \n .am-engine-view .data-codeblock-container {\n      margin: 5px 0;\n     \n }\n \n .am-content-editor .am-engine .data-codeblock-container .CodeMirror-lines {\n     min-height: 40px;\n }";
styleInject(css_248z);

var _modeNameMap = /*#__PURE__*/_classPrivateFieldLooseKey("modeNameMap");

var _modeSynatxMap = /*#__PURE__*/_classPrivateFieldLooseKey("modeSynatxMap");

var _viewAutoWrap = /*#__PURE__*/_classPrivateFieldLooseKey("viewAutoWrap");

var CodeBlcok = /*#__PURE__*/function (_Card) {
  _inherits(CodeBlcok, _Card);

  var _super = _createSuper(CodeBlcok);

  function CodeBlcok() {
    var _this;

    _classCallCheck(this, CodeBlcok);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.mirror = void 0;

    _this.resize = function () {
      var _this$codeEditor;

      return (_this$codeEditor = _this.codeEditor) === null || _this$codeEditor === void 0 ? void 0 : _this$codeEditor.container.find('.data-codeblock-content');
    };

    _this.codeEditor = void 0;
    Object.defineProperty(_assertThisInitialized(_this), _modeNameMap, {
      writable: true,
      value: {}
    });
    Object.defineProperty(_assertThisInitialized(_this), _modeSynatxMap, {
      writable: true,
      value: {}
    });
    Object.defineProperty(_assertThisInitialized(_this), _viewAutoWrap, {
      writable: true,
      value: undefined
    });
    return _this;
  }

  _createClass(CodeBlcok, [{
    key: "init",
    value: function init() {
      var _this2 = this;

      if (isServer) return;

      _get(_getPrototypeOf(CodeBlcok.prototype), "init", this).call(this);

      if (this.codeEditor) return;
      datas.forEach(function (item) {
        _classPrivateFieldLooseBase(_this2, _modeNameMap)[_modeNameMap][item.value] = item.name;
        _classPrivateFieldLooseBase(_this2, _modeSynatxMap)[_modeSynatxMap][item.value] = item.syntax;
      });
      this.codeEditor = new CodeBlockEditor(this.editor, {
        synatxMap: _classPrivateFieldLooseBase(this, _modeSynatxMap)[_modeSynatxMap],
        onSave: function onSave(mode, value) {
          var oldValue = _this2.getValue();

          if (mode === (oldValue === null || oldValue === void 0 ? void 0 : oldValue.mode) && value === oldValue.code) return;

          _this2.setValue({
            mode: mode,
            code: value
          });
        },
        onMouseDown: function onMouseDown(event) {
          if (!_this2.activated) setTimeout(function () {
            _this2.editor.card.activate(_this2.root, CardActiveTrigger.MOUSE_DOWN);
          }, 10);
        },
        onUpFocus: function onUpFocus(event) {
          var _this2$toolbarModel;

          if (!isEngine(_this2.editor)) return;
          event.preventDefault();
          var _this2$editor = _this2.editor,
              change = _this2$editor.change,
              card = _this2$editor.card;
          var range = change.range.get().cloneRange();

          var prev = _this2.root.prev();

          var cardComponent = prev ? card.find(prev) : undefined;

          if (cardComponent === null || cardComponent === void 0 ? void 0 : cardComponent.onSelectUp) {
            cardComponent.onSelectUp(event);
          } else if (prev) {
            card.focusPrevBlock(_this2, range, false);
            change.range.select(range);
          } else {
            _this2.focus(range, true);

            change.range.select(range);
            return;
          }

          _this2.activate(false);

          (_this2$toolbarModel = _this2.toolbarModel) === null || _this2$toolbarModel === void 0 ? void 0 : _this2$toolbarModel.hide();
        },
        onDownFocus: function onDownFocus(event) {
          var _this2$toolbarModel2;

          if (!isEngine(_this2.editor)) return;
          event.preventDefault();
          var _this2$editor2 = _this2.editor,
              change = _this2$editor2.change,
              card = _this2$editor2.card;
          var range = change.range.get().cloneRange();

          var next = _this2.root.next();

          var cardComponent = next ? card.find(next) : undefined;

          if (cardComponent === null || cardComponent === void 0 ? void 0 : cardComponent.onSelectDown) {
            cardComponent.onSelectDown(event);
          } else if (next) {
            card.focusNextBlock(_this2, range, false);
            change.range.select(range);
          } else {
            _this2.focus(range, false);

            change.range.select(range);
            return;
          }

          _this2.activate(false);

          (_this2$toolbarModel2 = _this2.toolbarModel) === null || _this2$toolbarModel2 === void 0 ? void 0 : _this2$toolbarModel2.hide();
        },
        onLeftFocus: function onLeftFocus(event) {
          var _this2$toolbarModel3;

          if (!isEngine(_this2.editor)) return;
          event.preventDefault();
          var change = _this2.editor.change;
          var range = change.range.get().cloneRange();

          _this2.focus(range, true);

          change.range.select(range);

          _this2.activate(false);

          (_this2$toolbarModel3 = _this2.toolbarModel) === null || _this2$toolbarModel3 === void 0 ? void 0 : _this2$toolbarModel3.hide();
        },
        onRightFocus: function onRightFocus(event) {
          var _this2$toolbarModel4;

          if (!isEngine(_this2.editor)) return;
          event.preventDefault();
          var change = _this2.editor.change;
          var range = change.range.get().cloneRange();

          _this2.focus(range, false);

          change.range.select(range);

          _this2.activate(false);

          (_this2$toolbarModel4 = _this2.toolbarModel) === null || _this2$toolbarModel4 === void 0 ? void 0 : _this2$toolbarModel4.hide();
        }
      });
    }
  }, {
    key: "toolbar",
    value: function toolbar() {
      var _this3 = this;

      if (this.loading) return [];

      if (!isEngine(this.editor) || this.editor.readonly) {
        return [{
          type: 'copy'
        }, {
          type: 'switch',
          content: this.editor.language.get(CodeBlcok.cardName, 'autoWrap'),
          getState: function getState() {
            if (_classPrivateFieldLooseBase(_this3, _viewAutoWrap)[_viewAutoWrap] === undefined) {
              var _this3$getValue;

              _classPrivateFieldLooseBase(_this3, _viewAutoWrap)[_viewAutoWrap] = !!((_this3$getValue = _this3.getValue()) === null || _this3$getValue === void 0 ? void 0 : _this3$getValue.autoWrap);
            }

            return _classPrivateFieldLooseBase(_this3, _viewAutoWrap)[_viewAutoWrap];
          },
          onClick: function onClick() {
            var _this3$codeEditor;

            var autoWrap = !_classPrivateFieldLooseBase(_this3, _viewAutoWrap)[_viewAutoWrap];
            _classPrivateFieldLooseBase(_this3, _viewAutoWrap)[_viewAutoWrap] = autoWrap;
            (_this3$codeEditor = _this3.codeEditor) === null || _this3$codeEditor === void 0 ? void 0 : _this3$codeEditor.setAutoWrap(autoWrap);
          }
        }];
      }

      return [{
        type: 'dnd'
      }, {
        type: 'copy'
      }, {
        type: 'delete'
      }, {
        type: 'node',
        node: $('<div />'),
        didMount: function didMount(node) {
          // 等待编辑插件渲染成功后才能去到mode
          setTimeout(function () {
            var _this3$codeEditor2;

            renderSelect(node.get(), _this3.constructor.getModes(), ((_this3$codeEditor2 = _this3.codeEditor) === null || _this3$codeEditor2 === void 0 ? void 0 : _this3$codeEditor2.mode) || 'plain', function (mode) {
              setTimeout(function () {
                var _this3$codeEditor3;

                _this3.focusEditor();

                window.localStorage.setItem('userCodeMode', mode);
                (_this3$codeEditor3 = _this3.codeEditor) === null || _this3$codeEditor3 === void 0 ? void 0 : _this3$codeEditor3.update(mode);
              }, 10);
            });
          }, 100);
        }
      } // 隐藏自动换行
      // {
      // 	type: 'switch',
      // 	content: this.editor.language.get<string>(
      // 		CodeBlcok.cardName,
      // 		'autoWrap',
      // 	),
      // 	getState: () => {
      // 		return !!this.getValue()?.autoWrap;
      // 	},
      // 	onClick: () => {
      // 		const value = this.getValue();
      // 		const autoWrap = !value?.autoWrap;
      // 		this.setValue({
      // 			autoWrap,
      // 		} as V);
      // 		this.codeEditor?.setAutoWrap(autoWrap);
      // 	},
      // },
      ];
    }
  }, {
    key: "focusEditor",
    value: function focusEditor() {
      var _this$codeEditor2;

      (_this$codeEditor2 = this.codeEditor) === null || _this$codeEditor2 === void 0 ? void 0 : _this$codeEditor2.focus();
      this.editor.card.activate(this.root);
    }
  }, {
    key: "onSelectLeft",
    value: function onSelectLeft(event) {
      var _this$toolbarModel;

      if (!this.codeEditor) return;
      event.preventDefault();
      this.codeEditor.focus();
      this.codeEditor.select(false);
      this.activate(true);
      (_this$toolbarModel = this.toolbarModel) === null || _this$toolbarModel === void 0 ? void 0 : _this$toolbarModel.show();
    }
  }, {
    key: "onSelectRight",
    value: function onSelectRight(event) {
      var _this$toolbarModel2;

      if (!this.codeEditor) return;
      event.preventDefault();
      this.codeEditor.focus();
      this.codeEditor.select(false);
      this.activate(true);
      (_this$toolbarModel2 = this.toolbarModel) === null || _this$toolbarModel2 === void 0 ? void 0 : _this$toolbarModel2.show();
    }
  }, {
    key: "onSelectDown",
    value: function onSelectDown(event) {
      var _this$toolbarModel3;

      if (!this.codeEditor) return;
      event.preventDefault();
      this.codeEditor.focus();
      this.activate(true);
      (_this$toolbarModel3 = this.toolbarModel) === null || _this$toolbarModel3 === void 0 ? void 0 : _this$toolbarModel3.show();
    }
  }, {
    key: "onSelectUp",
    value: function onSelectUp(event) {
      var _this$toolbarModel4;

      if (!this.codeEditor) return;
      event.preventDefault();
      this.codeEditor.focus();
      this.activate(true);
      (_this$toolbarModel4 = this.toolbarModel) === null || _this$toolbarModel4 === void 0 ? void 0 : _this$toolbarModel4.show();
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      if (!this.codeEditor) return;

      if (!this.codeEditor.container.inEditor()) {
        this.codeEditor.container = $(this.codeEditor.renderTemplate());
        this.mirror = undefined;
        this.getCenter().empty().append(this.codeEditor.container);
      }

      var value = this.getValue();
      var mode = (value === null || value === void 0 ? void 0 : value.mode) || 'plain';
      var code = (value === null || value === void 0 ? void 0 : value.code) || '';

      if (isEngine(this.editor)) {
        if (this.mirror) {
          this.codeEditor.update(mode, code);
          this.codeEditor.setAutoWrap(!!(value === null || value === void 0 ? void 0 : value.autoWrap));
          return;
        }

        setTimeout(function () {
          var _this4$codeEditor;

          _this4.mirror = (_this4$codeEditor = _this4.codeEditor) === null || _this4$codeEditor === void 0 ? void 0 : _this4$codeEditor.create(mode, code, {
            lineWrapping: !!(value === null || value === void 0 ? void 0 : value.autoWrap)
          });
        }, 50);
      } else {
        var _this$codeEditor3;

        (_this$codeEditor3 = this.codeEditor) === null || _this$codeEditor3 === void 0 ? void 0 : _this$codeEditor3.create(mode, code, {
          lineWrapping: !!(value === null || value === void 0 ? void 0 : value.autoWrap)
        });
      }
    }
  }], [{
    key: "cardName",
    get: function get() {
      return 'codeblock';
    }
  }, {
    key: "cardType",
    get: function get() {
      return CardType.BLOCK;
    }
  }, {
    key: "autoSelected",
    get: function get() {
      return false;
    }
  }, {
    key: "singleSelectable",
    get: function get() {
      return false;
    }
  }, {
    key: "getModes",
    value: function getModes() {
      return datas;
    }
  }, {
    key: "lazyRender",
    get: function get() {
      return true;
    }
  }]);

  return CodeBlcok;
}(Card);

var en = {
  codeblock: {
    autoWrap: 'Auto Wrap'
  }
};

var cn = {
  codeblock: {
    autoWrap: '自动换行'
  }
};

var locales = {
  'en-US': en,
  'zh-CN': cn
};

var MODE_ALIAS = {
  text: 'plain',
  sh: 'bash',
  ts: 'typescript',
  js: 'javascript',
  py: 'python',
  puml: 'plantuml',
  uml: 'plantuml',
  vb: 'basic',
  md: 'markdown',
  'c++': 'cpp',
  'c#': 'csharp'
};

var _default = /*#__PURE__*/function (_Plugin) {
  _inherits(_default, _Plugin);

  var _super = _createSuper(_default);

  function _default() {
    _classCallCheck(this, _default);

    return _super.apply(this, arguments);
  }

  _createClass(_default, [{
    key: "init",
    value: function init() {
      var _this = this;

      this.editor.language.add(locales);
      this.editor.on('parse:html', function (node) {
        return _this.parseHtml(node);
      });
      this.editor.on('paste:schema', function (schema) {
        return _this.pasteSchema(schema);
      });
      this.editor.on('paste:each', function (child) {
        return _this.pasteHtml(child);
      });

      if (isEngine(this.editor) && this.markdown) {
        this.editor.on('keydown:enter', function (event) {
          return _this.markdown(event);
        });
        this.editor.on('paste:markdown-check', function (child) {
          var _this$checkMarkdown;

          return !((_this$checkMarkdown = _this.checkMarkdown(child)) === null || _this$checkMarkdown === void 0 ? void 0 : _this$checkMarkdown.match);
        });
        this.editor.on('paste:markdown-before', function (child) {
          return _this.pasteMarkdown(child);
        });
      }
    }
  }, {
    key: "execute",
    value: function execute(mode, value) {
      if (!isEngine(this.editor)) return;
      var userCodeMode = window.localStorage.getItem('userCodeMode') || '';
      var card = this.editor.card;
      var component = card.insert(CodeBlcok.cardName, {
        mode: mode || userCodeMode,
        code: value
      });
      setTimeout(function () {
        component.focusEditor();
      }, 200);
    }
  }, {
    key: "hotkey",
    value: function hotkey() {
      return this.options.hotkey || '';
    }
  }, {
    key: "markdown",
    value: function markdown(event) {
      if (!isEngine(this.editor) || this.options.markdown === false) return;
      var _this$editor = this.editor,
          change = _this$editor.change,
          node = _this$editor.node,
          command = _this$editor.command;
      var blockApi = this.editor.block;
      var range = change.range.get();
      if (!range.collapsed || change.isComposing() || !this.markdown) return;
      var block = blockApi.closest(range.startNode);

      if (!node.isRootBlock(block)) {
        return;
      }

      var chars = blockApi.getLeftText(block);
      var match = /^`{3,}(.*){0,20}$/.exec(chars);

      if (match) {
        var modeText = (undefined === match[1] ? '' : match[1]).trim().toLowerCase();

        var alias = _objectSpread(_objectSpread({}, this.options.alias || {}), MODE_ALIAS);

        var mode = alias[modeText] || modeText;

        if (mode || mode === '') {
          event.preventDefault();
          blockApi.removeLeftText(block);
          command.execute(this.constructor.pluginName, mode);
          block.remove();
          return false;
        }
      }

      return;
    }
  }, {
    key: "pasteSchema",
    value: function pasteSchema(schema) {
      schema.add([{
        type: 'block',
        name: 'pre',
        attributes: {
          'data-syntax': '*',
          class: '*',
          language: '*'
        }
      }, {
        type: 'block',
        name: 'code',
        attributes: {
          'data-syntax': {
            required: true,
            value: '*'
          }
        }
      }, {
        type: 'block',
        name: 'code',
        attributes: {
          language: {
            required: true,
            value: '*'
          }
        }
      }, {
        type: 'block',
        name: 'code',
        attributes: {
          class: {
            required: true,
            value: '*'
          }
        }
      }, {
        type: 'block',
        name: 'div',
        attributes: {
          'data-syntax': {
            required: true,
            value: '*'
          }
        }
      }]);
    }
  }, {
    key: "pasteHtml",
    value: function pasteHtml(node) {
      var _node$get;

      if (!isEngine(this.editor) || node.isText()) return;

      if (((_node$get = node.get()) === null || _node$get === void 0 ? void 0 : _node$get.hasAttribute('data-syntax')) || node.name === 'pre') {
        var _node$html$match;

        var syntax = node.attributes('data-syntax');

        if (!syntax) {
          var getSyntaxForClass = function getSyntaxForClass(node) {
            var _node$get2;

            var classList = node === null || node === void 0 ? void 0 : (_node$get2 = node.get()) === null || _node$get2 === void 0 ? void 0 : _node$get2.classList;
            if (!classList) return;

            for (var i = 0; i < classList.length; i++) {
              var className = classList.item(i);

              if (className && className.startsWith('language-')) {
                var classArray = className.split('-');
                classArray.shift();
                return classArray.join('-');
              }
            }

            return undefined;
          };

          if (node.name === 'pre') {
            syntax = node.attributes('language') || node.attributes('data-lang');

            if (!syntax) {
              syntax = getSyntaxForClass(node);
            }
          }

          var _code = node.find('code');

          if (!syntax && _code.length > 0) {
            syntax = _code.attributes('data-syntax') || _code.attributes('language');

            if (!syntax) {
              syntax = getSyntaxForClass(_code);
            }
          }
        }

        var reg = /<\/code>/g;
        var len = (_node$html$match = node.html().match(reg)) === null || _node$html$match === void 0 ? void 0 : _node$html$match.length;
        node.html(node.html().replace(/<br>/gi, '\r\n'));

        if (len && len > 1) {
          node.html(node.html().replace(reg, '\n</code>'));
        }

        var code = new Parser(node, this.editor).toText(undefined, undefined, false);
        code = unescape(code.replace(/\u200b/g, '').trim());
        this.editor.card.replaceNode(node, 'codeblock', {
          mode: syntax || 'plain',
          code: code
        });
        node.remove();
        return false;
      }

      return true;
    }
  }, {
    key: "checkMarkdown",
    value: function checkMarkdown(node) {
      if (!isEngine(this.editor) || !this.markdown || !node.isText()) return;
      var text = node.text();
      if (!text) return;
      var reg = /`{3,}/;
      var match = reg.exec(text);
      return {
        reg: reg,
        match: match
      };
    }
  }, {
    key: "pasteMarkdown",
    value: function pasteMarkdown(node) {
      var _this2 = this;

      var result = this.checkMarkdown(node);
      if (!result) return;
      var match = result.match;
      if (!match) return;
      var card = this.editor.card;
      var newText = '';
      var nameMaps = {};
      CodeBlcok.getModes().forEach(function (item) {
        nameMaps[item.value] = item.name;
      });
      var langs = Object.keys(nameMaps).concat(Object.keys(MODE_ALIAS)).concat(Object.keys(this.options.alias || {})).sort(function (a, b) {
        return a.length > b.length ? -1 : 1;
      });

      var createCodeblock = function createCodeblock(nodes) {
        var _carNode$get;

        var mode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'text';
        //获取中间字符
        var codeText = nodes.join('\n');
        var code = unescape(codeText);
        if (code.endsWith('\n')) code = code.substr(0, code.length - 1);
        var tempNode = $('<div></div>');
        var carNode = card.replaceNode(tempNode, 'codeblock', {
          mode: mode,
          code: code
        });
        tempNode.remove();
        return (_carNode$get = carNode.get()) === null || _carNode$get === void 0 ? void 0 : _carNode$get.outerHTML;
      };

      var codeLength = 0;
      var rows = node.text().split(/\n|\r\n/);
      var nodes = [];
      var isCode = false;
      var mode = 'text';
      rows.forEach(function (row) {
        var match = /^(.*)`{3,}(\s)*$/.exec(row);

        if (match && isCode) {
          nodes.push(match[1]);
          newText += createCodeblock(nodes, mode) + '\n';
          mode = 'text';
          isCode = false;
          nodes = [];
          return;
        }

        match = /(\s*)```(.*)/.exec(row);
        match ? codeLength = match[1].length : 0;

        if (match) {
          isCode = true;
          mode = langs.find(function (key) {
            return match && (match[2] || '').trim().toLowerCase().indexOf(key) === 0;
          }) || 'text'; // let code =
          // 	match[1].indexOf(mode) === 0
          // 		? match[1].substr(mode.length + 1)
          // 		: match[1];

          var alias = _objectSpread(_objectSpread({}, _this2.options.alias || {}), MODE_ALIAS);

          mode = alias[mode] || mode;
        } else if (isCode) {
          nodes.push(row.substring(codeLength));
        } else {
          newText += row + '\n';
        }
      });

      if (nodes.length > 0) {
        newText += createCodeblock(nodes, mode) + '\n';
      }

      node.text(newText);
    }
  }, {
    key: "parseHtml",
    value: function parseHtml(root) {
      var _this3 = this;

      if (isServer) return;
      root.find("[".concat(CARD_KEY, "=\"").concat(CodeBlcok.cardName, "\"],[").concat(READY_CARD_KEY, "=\"").concat(CodeBlcok.cardName, "\"]")).each(function (cardNode) {
        var node = $(cardNode);

        var card = _this3.editor.card.find(node);

        var value = (card === null || card === void 0 ? void 0 : card.getValue()) || decodeCardValue(node.attributes(CARD_VALUE_KEY));

        if (value) {
          node.empty();
          var synatxMap = {};
          CodeBlcok.getModes().forEach(function (item) {
            synatxMap[item.value] = item.syntax;
          });
          var codeEditor = new CodeBlockEditor(_this3.editor, {
            synatxMap: synatxMap
          });
          var content = codeEditor.container.find('.data-codeblock-content');
          content.css({
            border: '1px solid #e8e8e8',
            'max-width': '750px'
          });
          codeEditor.render(value.mode || 'plain', value.code ? value.code.trim() : '');
          content.addClass('am-engine-view');
          content.hide();
          document.body.appendChild(content[0]);
          content.traverse(function (node) {
            var _node$get3, _node$get3$classList;

            if (node.type === Node.ELEMENT_NODE && (((_node$get3 = node.get()) === null || _node$get3 === void 0 ? void 0 : (_node$get3$classList = _node$get3.classList) === null || _node$get3$classList === void 0 ? void 0 : _node$get3$classList.length) || 0) > 0) {
              var element = node.get();
              var style = window.getComputedStyle(element);
              ['color', 'margin', 'padding', 'background'].forEach(function (attr) {
                element.style[attr] = style.getPropertyValue(attr);
              });
            }
          });
          content.show();
          content.css('background', '#f9f9f9');
          content.html(content.html().replace(/((<br>)*\s)*<\/pre>/gi, '</pre>'));
          node.append(content);
          node.removeAttributes(CARD_KEY);
          node.removeAttributes(CARD_TYPE_KEY);
          node.removeAttributes(CARD_VALUE_KEY);
          node.attributes('data-syntax', value.mode || 'plain');
          content.removeClass('am-engine-view');
        } else node.remove();
      });
    }
  }], [{
    key: "pluginName",
    get: function get() {
      return 'codeblock';
    }
  }]);

  return _default;
}(Plugin);

export default _default;
export { CodeBlcok as CodeBlockComponent };
